Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_transition.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_transition.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Read_queue/src/Read_queue_transition.cpp	(revision 88)
@@ -24,5 +24,6 @@
   void Read_queue::transition (void)
   {
-    log_printf(FUNC,Read_queue,FUNCTION,"Begin");
+    log_begin(Read_queue,FUNCTION);
+    log_function(Read_queue,FUNCTION,_name.c_str());
 
     if (PORT_READ(in_NRESET) == 0)
@@ -33,6 +34,8 @@
 	// > 2) flush all slot in one cycle
 
-	while (_queue->empty() == false)
-	  _queue->pop();
+        _queue->clear();
+
+	// Init, else error in registerfile
+	_queue_head->_ooo_engine_id = 0;
       }
     else
@@ -44,5 +47,5 @@
 // 	  cout << (*_queue_head) << endl;
 
-	log_printf(TRACE,Read_queue,FUNCTION,"Read_queue size (begin) : %d",_queue->size());
+	log_printf(TRACE,Read_queue,FUNCTION,"  * Read_queue size (begin) : %d",(int)_queue->size());
 	// Write to read_queue
 
@@ -51,5 +54,5 @@
 	bool need_new_head = false;
 	
-	log_printf(TRACE,Read_queue,FUNCTION," * test transaction READ_QUEUE_IN  : %d,%d",PORT_READ(in_READ_QUEUE_IN_VAL), not_full);
+	log_printf(TRACE,Read_queue,FUNCTION,"    * test transaction READ_QUEUE_IN  : %d,%d",PORT_READ(in_READ_QUEUE_IN_VAL), not_full);
 	if ((PORT_READ(in_READ_QUEUE_IN_VAL) == 1) and not_full)
 	  {
@@ -62,5 +65,5 @@
 	    if(_param->_have_port_ooo_engine_id)
 	      entry->_ooo_engine_id= PORT_READ(in_READ_QUEUE_IN_OOO_ENGINE_ID);
-	    if(_param->_have_port_rob_id       )
+	    if(_param->_have_port_rob_ptr      )
 	      entry->_rob_id       = PORT_READ(in_READ_QUEUE_IN_ROB_ID      );
 	    entry->_operation    = PORT_READ(in_READ_QUEUE_IN_OPERATION   );
@@ -82,12 +85,11 @@
 	    entry->_num_reg_re   = PORT_READ(in_READ_QUEUE_IN_NUM_REG_RE  );
 
-	    log_printf(TRACE,Read_queue,FUNCTION,"   * push (id : %d-%d)",entry->_context_id, entry->_rob_id);
-	    _queue->push(entry);
-
+	    log_printf(TRACE,Read_queue,FUNCTION,"    * push (id : %d-%d)",entry->_context_id, entry->_rob_id);
+	    _queue->push_back(entry);
 
 	    // read next new head
 	    if (empty)
 	      {
-		log_printf(TRACE,Read_queue,FUNCTION,"     * queue was    empty");
+		log_printf(TRACE,Read_queue,FUNCTION,"    * queue was    empty");
 		need_new_head = true;
 	      }
@@ -95,16 +97,16 @@
 
 	// Read from read_queue
-	log_printf(TRACE,Read_queue,FUNCTION," * test transaction READ_QUEUE_OUT : %d,%d",internal_READ_QUEUE_OUT_VAL, PORT_READ(in_READ_QUEUE_OUT_ACK));
+	log_printf(TRACE,Read_queue,FUNCTION,"  * test transaction READ_QUEUE_OUT : %d,%d",internal_READ_QUEUE_OUT_VAL, PORT_READ(in_READ_QUEUE_OUT_ACK));
 	if ((    internal_READ_QUEUE_OUT_VAL  == 1) and 
 	    (PORT_READ(in_READ_QUEUE_OUT_ACK) == 1))
 	  {
 	    // Pop the entry
-	    log_printf(TRACE,Read_queue,FUNCTION,"   * pop  (id : %d-%d)",_queue->front()->_context_id, _queue->front()->_rob_id);
-	    _queue->pop();
+	    log_printf(TRACE,Read_queue,FUNCTION,"    * pop  (id : %d-%d)",_queue->front()->_context_id, _queue->front()->_rob_id);
+	    _queue->pop_front();
 
 	    // read next new head
 	    if (_queue->empty() == false)
 	      {
-		log_printf(TRACE,Read_queue,FUNCTION,"     * queue was not empty");
+		log_printf(TRACE,Read_queue,FUNCTION,"    * queue was not empty");
 		need_new_head = true;
 	      }
@@ -128,5 +130,5 @@
 	if (need_new_head == true)
 	  {
-	    log_printf(TRACE,Read_queue,FUNCTION," * new head");
+	    log_printf(TRACE,Read_queue,FUNCTION,"  * new head");
 	    (*_queue_head) = (*_queue->front());
 	  }
@@ -138,12 +140,119 @@
 // 	  cout << (*_queue_head) << endl;
 
-	log_printf(TRACE,Read_queue,FUNCTION,"Read_queue size (end  ) : %d",_queue->size());
+#if (DEBUG >= DEBUG_TRACE) and (DEBUG_Read_queue == true)
+	log_printf(TRACE,Read_queue,FUNCTION,"  * Dump Read_queue");
+	log_printf(TRACE,Read_queue,FUNCTION,"    * size : %d",(int)_queue->size());
+
+        if (_queue->size()>0)
+          {
+//   protected : Tread_queue_head_entry_t       * _queue_head;
+//   protected : std::queue<Tread_queue_entry_t *>   * _queue;
+            
+            log_printf(TRACE,Read_queue,FUNCTION,"    * [%.4d] %.2d %.2d %.2d %.4d, %.2d %.3d, %.2d %.2d, %.1d %.8x, %.1d %.1d %.4d %.1d %.8x, %.1d %.1d %.4d %.1d %.8x, %.1d %.1d %.4d %.1d %.2x, %.1d %.4d, %.1d %.4d (%s)",
+                       0,
+
+                       _queue_head->_context_id           ,
+                       _queue_head->_front_end_id         ,
+                       _queue_head->_ooo_engine_id        ,
+                       _queue_head->_rob_id               ,
+
+                       _queue_head->_type                 ,
+                       _queue_head->_operation            ,
+
+                       _queue_head->_store_queue_ptr_write,
+                       _queue_head->_load_queue_ptr_write ,
+
+                       _queue_head->_has_immediat         ,
+                       _queue_head->_immediat             ,
+
+                       _queue_head->_read_ra              ,
+                       _queue_head->_read_ra_val          ,
+                       _queue_head->_num_reg_ra           ,
+                       _queue_head->_data_ra_val          ,
+                       _queue_head->_data_ra              ,
+
+                       _queue_head->_read_rb              ,
+                       _queue_head->_read_rb_val          ,
+                       _queue_head->_num_reg_rb           ,
+                       _queue_head->_data_rb_val          ,
+                       _queue_head->_data_rb              ,
+
+                       _queue_head->_read_rc              ,
+                       _queue_head->_read_rc_val          ,
+                       _queue_head->_num_reg_rc           ,
+                       _queue_head->_data_rc_val          ,
+                       _queue_head->_data_rc              ,
+
+                       _queue_head->_write_rd             ,
+                       _queue_head->_num_reg_rd           ,
+                       
+                       _queue_head->_write_re             ,
+                       _queue_head->_num_reg_re           ,
+
+                       toString_type(_queue_head->_type).c_str());
+
+
+            std::list<Tread_queue_entry_t *>::iterator it=_queue->begin();
+            ++it; // first is already printed
+            uint32_t i=1;
+
+            for (;it!=_queue->end(); ++it)
+              {
+                log_printf(TRACE,Read_queue,FUNCTION,"    * [%.4d] %.2d %.2d %.2d %.4d, %.2d %.3d, %.2d %.2d, %.1d %.8x, %.1d   %.4d           , %.1d   %.4d           , %.1d   %.4d     , %.1d %.4d, %.1d %.4d (%s)",
+                           i,
+                           
+                           (*it)->_context_id           ,
+                           (*it)->_front_end_id         ,
+                           (*it)->_ooo_engine_id        ,
+                           (*it)->_rob_id               ,
+                           
+                           (*it)->_type                 ,
+                           (*it)->_operation            ,
+                           
+                           (*it)->_store_queue_ptr_write,
+                           (*it)->_load_queue_ptr_write ,
+                           
+                           (*it)->_has_immediat         ,
+                           (*it)->_immediat             ,
+                           
+                           (*it)->_read_ra              ,
+//                         (*it)->_read_ra_val          ,
+                           (*it)->_num_reg_ra           ,
+//                         (*it)->_data_ra_val          ,
+//                         (*it)->_data_ra              ,
+                           
+                           (*it)->_read_rb              ,
+//                         (*it)->_read_rb_val          ,
+                           (*it)->_num_reg_rb           ,
+//                         (*it)->_data_rb_val          ,
+//                         (*it)->_data_rb              ,
+                           
+                           (*it)->_read_rc              ,
+//                         (*it)->_read_rc_val          ,
+                           (*it)->_num_reg_rc           ,
+//                         (*it)->_data_rc_val          ,
+//                         (*it)->_data_rc              ,
+                           
+                           (*it)->_write_rd             ,
+                           (*it)->_num_reg_rd           ,
+                           
+                           (*it)->_write_re             ,
+                           (*it)->_num_reg_re           ,
+
+                           toString_type((*it)->_type).c_str());
+
+                ++i;
+              }
+          }
+#endif
+
+
       }
 
 #if defined(STATISTICS) or defined(VHDL_TESTBENCH)
-    end_cycle ();
+        end_cycle ();
 #endif
 
-    log_printf(FUNC,Read_queue,FUNCTION,"End");
+    log_end(Read_queue,FUNCTION);
   };
 
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/Makefile
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/Makefile	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/Makefile	(revision 88)
@@ -24,4 +24,6 @@
 library_clean			: Reservation_station_library_clean
 
+local_clean			:
+
 include                         ../Makefile.deps
 include                         $(DIR_MORPHEO)/Behavioural/Makefile.flags
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/include/test.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/include/test.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/include/test.h	(revision 88)
@@ -15,4 +15,5 @@
 #include <sys/time.h>
 
+#include "Common/include/Time.h"
 #include "Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Reservation_station.h"
 
@@ -31,33 +32,2 @@
 	      morpheo::behavioural::core::multi_execute_loop::execute_loop::multi_read_unit::read_unit::reservation_station::Parameters * param);
 
-class Time 
-{
-private : timeval time_begin;
-// private : timeval time_end;
-  
-public  : Time ()
-  {
-    gettimeofday(&time_begin     ,NULL);
-  };
-
-public  : ~Time ()
-  {
-    cout << *this;
-  };
-
-public  : friend ostream& operator<< (ostream& output_stream,
-				      const Time & x)
-  {
-    timeval time_end;
-    
-    gettimeofday(&time_end       ,NULL);
-    
-    uint32_t nb_cycles = static_cast<uint32_t>(sc_simulation_time());
-
-    double average = static_cast<double>(nb_cycles) / static_cast<double>(time_end.tv_sec-x.time_begin.tv_sec);
-    
-    output_stream << nb_cycles << "\t(" << average << " cycles / seconds )" << endl;
-
-    return output_stream;
-  }
-};
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/main.cpp	(revision 88)
@@ -86,4 +86,5 @@
 	 ,size_store_queue
 	 ,size_load_queue 
+         ,true //is_toplevel
 	 );
       
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/SelfTest/src/test.cpp	(revision 88)
@@ -22,4 +22,14 @@
 #endif
 
+  Tusage_t _usage = USE_ALL;
+
+//   _usage = usage_unset(_usage,USE_SYSTEMC              );
+//   _usage = usage_unset(_usage,USE_VHDL                 );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH       );
+//   _usage = usage_unset(_usage,USE_VHDL_TESTBENCH_ASSERT);
+//   _usage = usage_unset(_usage,USE_POSITION             );
+   _usage = usage_unset(_usage,USE_STATISTICS           );
+//   _usage = usage_unset(_usage,USE_INFORMATION          );
+
   Reservation_station * _Reservation_station = new Reservation_station 
     (name.c_str(),
@@ -28,5 +38,5 @@
 #endif
      _param,
-     USE_ALL);
+     _usage);
   
 #ifdef SYSTEMC
@@ -185,5 +195,5 @@
   if (_param->_have_port_ooo_engine_id)
   (*(_Reservation_station-> in_INSERT_OOO_ENGINE_ID    )) (*( in_INSERT_OOO_ENGINE_ID    ));
-  if (_param->_have_port_rob_id)
+  if (_param->_have_port_rob_ptr)
   (*(_Reservation_station-> in_INSERT_ROB_ID           )) (*( in_INSERT_ROB_ID           ));
   (*(_Reservation_station-> in_INSERT_OPERATION        )) (*( in_INSERT_OPERATION        ));
@@ -221,5 +231,5 @@
   if (_param->_have_port_ooo_engine_id)
   (*(_Reservation_station->out_RETIRE_OOO_ENGINE_ID  [i])) (*(out_RETIRE_OOO_ENGINE_ID  [i]));
-  if (_param->_have_port_rob_id)
+  if (_param->_have_port_rob_ptr)
   (*(_Reservation_station->out_RETIRE_ROB_ID         [i])) (*(out_RETIRE_ROB_ID         [i]));
   (*(_Reservation_station->out_RETIRE_OPERATION      [i])) (*(out_RETIRE_OPERATION      [i]));
@@ -417,5 +427,5 @@
    	      if (_param->_have_port_ooo_engine_id)
               in_INSERT_OOO_ENGINE_ID  ->write(insert_ooo_engine_id);
-   	      if (_param->_have_port_rob_id)
+   	      if (_param->_have_port_rob_ptr)
               in_INSERT_ROB_ID      ->write(request_in);
    	      in_INSERT_OPERATION   ->write(0);
@@ -610,5 +620,5 @@
 		{
 		  Tpacket_t  rob_id;
-		  if (_param->_have_port_rob_id)
+		  if (_param->_have_port_rob_ptr)
 		    rob_id = out_RETIRE_ROB_ID [i]->read();
 		  else
@@ -667,5 +677,5 @@
   if (_param->_have_port_ooo_engine_id)  
   delete     in_INSERT_OOO_ENGINE_ID  ;
-  if (_param->_have_port_rob_id)  
+  if (_param->_have_port_rob_ptr)  
   delete     in_INSERT_ROB_ID      ;
   delete     in_INSERT_OPERATION   ;
@@ -701,5 +711,5 @@
   if (_param->_have_port_ooo_engine_id)  
   delete [] out_RETIRE_OOO_ENGINE_ID  ;
-  if (_param->_have_port_rob_id)  
+  if (_param->_have_port_rob_ptr)  
   delete [] out_RETIRE_ROB_ID   ;
   delete [] out_RETIRE_OPERATION   ;
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/include/Parameters.h	(revision 88)
@@ -26,41 +26,40 @@
   {
     //-----[ fields ]------------------------------------------------------------
-  public : const uint32_t    _size_queue           ;
-  public : const uint32_t    _nb_inst_retire       ;
-  public : const uint32_t    _nb_context           ;
-  public : const uint32_t    _nb_front_end         ;
-  public : const uint32_t    _nb_ooo_engine        ;
-  public : const uint32_t    _nb_packet            ;
-  public : const uint32_t    _size_general_data    ;
-  public : const uint32_t    _size_special_data    ;
-  public : const uint32_t    _nb_general_register  ;
-  public : const uint32_t    _nb_special_register  ;
-  public : const uint32_t    _nb_gpr_write         ;
-  public : const uint32_t    _nb_spr_write         ;
-  public : const uint32_t    _nb_bypass_write      ;//if nb_bypass=0, then bypass is desactivated
-  public : const uint32_t    _nb_bypass_memory     ;//if nb_bypass=0, then bypass is desactivated
-  public : const uint32_t    _size_store_queue     ;
-  public : const uint32_t    _size_load_queue      ;
+  public : uint32_t    _size_queue           ;
+  public : uint32_t    _nb_inst_retire       ;
+  public : uint32_t    _nb_context           ;
+  public : uint32_t    _nb_front_end         ;
+  public : uint32_t    _nb_ooo_engine        ;
+  public : uint32_t    _nb_packet            ;
+//public : uint32_t    _size_general_data    ;
+//public : uint32_t    _size_special_data    ;
+  public : uint32_t    _nb_general_register  ;
+  public : uint32_t    _nb_special_register  ;
+  public : uint32_t    _nb_gpr_write         ;
+  public : uint32_t    _nb_spr_write         ;
+  public : uint32_t    _nb_bypass_write      ;//if nb_bypass=0, then bypass is desactivated
+  public : uint32_t    _nb_bypass_memory     ;//if nb_bypass=0, then bypass is desactivated
+//public : uint32_t    _size_store_queue     ;
+//public : uint32_t    _size_load_queue      ;
+    /*
+  public : bool        _have_immediat        ;
+  public : bool        _have_gpr_ra          ;
+  public : bool        _have_gpr_rb          ;
+  public : bool        _have_spr_rc          ;
+  public : bool        _have_gpr_rd          ;
+  public : bool        _have_spr_re          ;
+    */
+//public : uint32_t    _size_context_id      ;
+//public : uint32_t    _size_front_end_id    ;
+//public : uint32_t    _size_ooo_engine_id   ;
+//public : uint32_t    _size_rob_ptr         ;
+//public : uint32_t    _size_general_register;
+//public : uint32_t    _size_special_register;
 
-    /*
-  public : const bool        _have_immediat        ;
-  public : const bool        _have_gpr_ra          ;
-  public : const bool        _have_gpr_rb          ;
-  public : const bool        _have_spr_rc          ;
-  public : const bool        _have_gpr_rd          ;
-  public : const bool        _have_spr_re          ;
-    */
-  public : const uint32_t    _size_context_id      ;
-  public : const uint32_t    _size_front_end_id    ;
-  public : const uint32_t    _size_ooo_engine_id   ;
-  public : const uint32_t    _size_rob_id          ;
-  public : const uint32_t    _size_general_register;
-  public : const uint32_t    _size_special_register;
-
-  public : const bool        _have_port_context_id   ;
-  public : const bool        _have_port_front_end_id ;
-  public : const bool        _have_port_ooo_engine_id;
-  public : const bool        _have_port_rob_id       ;
-  public : const bool        _have_port_load_queue_ptr;
+//public : bool        _have_port_context_id   ;
+//public : bool        _have_port_front_end_id ;
+//public : bool        _have_port_ooo_engine_id;
+//public : bool        _have_port_rob_ptr      ;
+//public : bool        _have_port_load_queue_ptr;
 
     //-----[ methods ]-----------------------------------------------------------
@@ -80,8 +79,11 @@
 			uint32_t nb_bypass_memory   ,
 			uint32_t size_store_queue   ,
-			uint32_t size_load_queue    );
+			uint32_t size_load_queue    ,
+                        bool     is_toplevel=false);
 
-  public : Parameters  (Parameters & param) ;
+//   public : Parameters  (Parameters & param) ;
   public : ~Parameters () ;
+
+  public :        void            copy       (void);
 
   public :        Parameters_test msg_error  (void);
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters.cpp	(revision 88)
@@ -35,81 +35,98 @@
 			  uint32_t nb_bypass_memory   ,
 			  uint32_t size_store_queue   ,
-			  uint32_t size_load_queue    ):
-    _size_queue            (size_queue           ),
-    _nb_inst_retire        (nb_inst_retire       ),
-    _nb_context            (nb_context           ),
-    _nb_front_end          (nb_front_end         ),
-    _nb_ooo_engine         (nb_ooo_engine        ),
-    _nb_packet             (nb_packet            ),
-    _size_general_data     (size_general_data    ),
-    _size_special_data     (size_special_data    ),
-    _nb_general_register   (nb_general_register  ),
-    _nb_special_register   (nb_special_register  ),
-    _nb_gpr_write          (nb_gpr_write         ),
-    _nb_spr_write          (nb_spr_write         ),
-    _nb_bypass_write       (nb_bypass_write      ),
-    _nb_bypass_memory      (nb_bypass_memory     ),
-    _size_store_queue      (size_store_queue     ),
-    _size_load_queue       (size_load_queue      ),
-
-    _size_context_id       (static_cast<uint32_t>(log2(_nb_context         ))),
-    _size_front_end_id     (static_cast<uint32_t>(log2(_nb_front_end       ))),
-    _size_ooo_engine_id    (static_cast<uint32_t>(log2(_nb_ooo_engine      ))),
-    _size_rob_id           (static_cast<uint32_t>(log2(_nb_packet          ))),
-    _size_general_register (static_cast<uint32_t>(log2(_nb_general_register))),
-    _size_special_register (static_cast<uint32_t>(log2(_nb_special_register))),
-
-    _have_port_context_id    (_size_context_id    > 0),
-    _have_port_front_end_id  (_size_front_end_id  > 0),
-    _have_port_ooo_engine_id (_size_ooo_engine_id > 0),
-    _have_port_rob_id        (_size_rob_id        > 0),
-    _have_port_load_queue_ptr(_size_load_queue    > 1)
+			  uint32_t size_load_queue    ,
+                          bool     is_toplevel)
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
+
+    _size_queue              = size_queue           ;
+    _nb_inst_retire          = nb_inst_retire       ;
+    _nb_context              = nb_context           ;
+    _nb_front_end            = nb_front_end         ;
+    _nb_ooo_engine           = nb_ooo_engine        ;
+    _nb_packet               = nb_packet            ;
+    _nb_general_register     = nb_general_register  ;
+    _nb_special_register     = nb_special_register  ;
+    _nb_gpr_write            = nb_gpr_write         ;
+    _nb_spr_write            = nb_spr_write         ;
+    _nb_bypass_write         = nb_bypass_write      ;
+    _nb_bypass_memory        = nb_bypass_memory     ;
+
     test();
+
+    if (is_toplevel)
+      {
+        _size_context_id         = log2(_nb_context         );
+        _size_front_end_id       = log2(_nb_front_end       );
+        _size_ooo_engine_id      = log2(_nb_ooo_engine      );
+        _size_rob_ptr            = log2(_nb_packet          );
+        _size_general_register   = log2(_nb_general_register);
+        _size_special_register   = log2(_nb_special_register);
+        _size_general_data       = size_general_data         ;
+        _size_special_data       = size_special_data         ;
+        _size_store_queue_ptr    = log2(size_store_queue    );
+        _size_load_queue_ptr     = log2(size_load_queue     );
+        
+        _have_port_context_id    = _size_context_id     > 0;
+        _have_port_front_end_id  = _size_front_end_id   > 0;
+        _have_port_ooo_engine_id = _size_ooo_engine_id  > 0;
+        _have_port_rob_ptr       = _size_rob_ptr        > 0;
+        _have_port_load_queue_ptr= _size_load_queue_ptr > 0;
+
+        copy();
+      }
+
     log_printf(FUNC,Reservation_station,FUNCTION,"End");
   };
   
+// #undef  FUNCTION
+// #define FUNCTION "Reservation_station::Parameters (copy)"
+//   Parameters::Parameters (Parameters & param):
+//     _size_queue            (param._size_queue            ),
+//     _nb_inst_retire        (param._nb_inst_retire        ),
+//     _nb_context            (param._nb_context            ),
+//     _nb_front_end          (param._nb_front_end          ),
+//     _nb_ooo_engine         (param._nb_ooo_engine         ),
+//     _nb_packet             (param._nb_packet             ),
+//     _size_general_data     (param._size_general_data     ),
+//     _size_special_data     (param._size_special_data     ),
+//     _nb_general_register   (param._nb_general_register   ),
+//     _nb_special_register   (param._nb_special_register   ),
+//     _nb_gpr_write          (param._nb_gpr_write          ),
+//     _nb_spr_write          (param._nb_spr_write          ),
+//     _nb_bypass_write       (param._nb_bypass_write       ),
+//     _nb_bypass_memory      (param._nb_bypass_memory      ),
+//     _size_store_queue      (param._size_store_queue      ),
+//     _size_load_queue       (param._size_load_queue       ),
+
+//     _size_context_id       (param._size_context_id       ),
+//     _size_front_end_id     (param._size_front_end_id     ),
+//     _size_ooo_engine_id    (param._size_ooo_engine_id    ),
+//     _size_rob_id           (param._size_rob_id           ),
+//     _size_general_register (param._size_general_register ),
+//     _size_special_register (param._size_special_register ),
+
+//     _have_port_context_id    (param._have_port_context_id   ),
+//     _have_port_front_end_id  (param._have_port_front_end_id ),
+//     _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
+//     _have_port_rob_id        (param._have_port_rob_id       ),
+//     _have_port_load_queue_ptr(param._have_port_load_queue_ptr)
+//   {
+//     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
+//     test();
+//     log_printf(FUNC,Reservation_station,FUNCTION,"End");
+//   };
+
 #undef  FUNCTION
-#define FUNCTION "Reservation_station::Parameters (copy)"
-  Parameters::Parameters (Parameters & param):
-    _size_queue            (param._size_queue            ),
-    _nb_inst_retire        (param._nb_inst_retire        ),
-    _nb_context            (param._nb_context            ),
-    _nb_front_end          (param._nb_front_end          ),
-    _nb_ooo_engine         (param._nb_ooo_engine         ),
-    _nb_packet             (param._nb_packet             ),
-    _size_general_data     (param._size_general_data     ),
-    _size_special_data     (param._size_special_data     ),
-    _nb_general_register   (param._nb_general_register   ),
-    _nb_special_register   (param._nb_special_register   ),
-    _nb_gpr_write          (param._nb_gpr_write          ),
-    _nb_spr_write          (param._nb_spr_write          ),
-    _nb_bypass_write       (param._nb_bypass_write       ),
-    _nb_bypass_memory      (param._nb_bypass_memory      ),
-    _size_store_queue      (param._size_store_queue      ),
-    _size_load_queue       (param._size_load_queue       ),
-
-    _size_context_id       (param._size_context_id       ),
-    _size_front_end_id     (param._size_front_end_id     ),
-    _size_ooo_engine_id    (param._size_ooo_engine_id    ),
-    _size_rob_id           (param._size_rob_id           ),
-    _size_general_register (param._size_general_register ),
-    _size_special_register (param._size_special_register ),
-
-    _have_port_context_id    (param._have_port_context_id   ),
-    _have_port_front_end_id  (param._have_port_front_end_id ),
-    _have_port_ooo_engine_id (param._have_port_ooo_engine_id),
-    _have_port_rob_id        (param._have_port_rob_id       ),
-    _have_port_load_queue_ptr(param._have_port_load_queue_ptr)
+#define FUNCTION "Reservation_station::~Parameters"
+  Parameters::~Parameters (void) 
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
-    test();
     log_printf(FUNC,Reservation_station,FUNCTION,"End");
   };
 
 #undef  FUNCTION
-#define FUNCTION "Reservation_station::~Parameters"
-  Parameters::~Parameters () 
+#define FUNCTION "Reservation_station::copy"
+  void Parameters::copy (void) 
   {
     log_printf(FUNC,Reservation_station,FUNCTION,"Begin");
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Execute_loop/Execute_loop/Multi_Read_unit/Read_unit/Reservation_station/src/Parameters_print.cpp	(revision 88)
@@ -42,6 +42,6 @@
     xml.singleton_begin("nb_bypass_write    "); xml.attribut("value",toString(_nb_bypass_write    )); xml.singleton_end();
     xml.singleton_begin("nb_bypass_memory   "); xml.attribut("value",toString(_nb_bypass_memory   )); xml.singleton_end();
-    xml.singleton_begin("size_store_queue   "); xml.attribut("value",toString(_size_store_queue   )); xml.singleton_end();
-    xml.singleton_begin("size_load_queue    "); xml.attribut("value",toString(_size_load_queue    )); xml.singleton_end();
+//  xml.singleton_begin("size_store_queue   "); xml.attribut("value",toString(_size_store_queue   )); xml.singleton_end();
+//  xml.singleton_begin("size_load_queue    "); xml.attribut("value",toString(_size_load_queue    )); xml.singleton_end();
     xml.balise_close();
 
